# PyFocus

Author: Fernando Caprile (fcaprile@gmail.com)

Supervisors: Luciano A. Masullo (lmasullo@df.uba.ar), Fernando D. Stefani (fernando.stefani@df.uba.ar)

Affiliation: Physics Department, Faculty of Natural and Exact Sciences, University of Buenos Aires and Center for Bionanoscience Research (CIBION), National Scientific and Technical Research Council (CONICET)

This is PyFocus, a Python package that provides high-level functions and an user interface to perform full vectorial calculations of the focus of an electromagnetic field that has been modulated by a custom phase mask, while providing the option of simulating the free propagation of these fields under the paraxial approximation and the focus through an interface or a multilayer system.

You can find detailed information about the theorical calculations used in this package and a full description of many common use cases in the following paper: https://doi.org/10.1016/j.cpc.2022.108315. If use this package for your research, please cite this work.

For a quick windows executable program, download and run "PyFocus.exe"

See the full documentation and installation tutorial at: https://pyfocus.readthedocs.io/en/latest/


